=== debian/changelog ===
mlton (20241230+git20251029+dfsg-1) unstable; urgency=medium

  * New upstream release fixes many build issues (DFSG-repacked upstream
    commit 61baac7108fbd91413f0537b7a42d9a1023455f4) (Closes: #1103850)
    + Now successfully rebuilds itself on hppa and i386 (Closes: #1003240)
    + Fix FTBFS on ppc64el (Closes: #1007016)
    + Fix segfault in tests (Closes: #917644)
    + Drop 06_local_docs.diff, no longer needed
  * Debian GNU/kFreeBSD has been terminated. Drop 03_kfreebsd.diff and
    corresponding binary packages
  * Improvements to README.source:
    + Update instructions for repacking DFSG-clean source tarball
    + Update (re)bootstrapping instructions for new architectures
  * Simplify bootstrapping on new architectures with schroot,
    09_schroot_bootstrap.diff
  * Upstream now uses asciidoctor instead of asciidoc. Update
    Build-Depends-Indep accordingly.
  * Upgrade watch file to version 5
  * Bump standards version to 4.7.2

 -- Ryan Kavanagh <rak@debian.org>  Mon, 03 Nov 2025 08:38:10 -0500
