=== debian/watch ===
Version: 5
Template: GitHub
Owner: MLton
Project: mlton
Uversion-Mangle: s/-release$//
Dversion-Mangle: auto
